/* ISC license. */

#include <errno.h>
#include "uint16.h"
#include "uint32.h"
#include "bytestr.h"
#include "tai.h"
#include "gensetdyn.h"
#include "skaclient.h"
#include "s6lock.h"

int s6lock_acquire (s6lock_t_ref a, uint16 *u, char const *path, uint32 options, struct taia const *limit, struct taia const *deadline, struct taia *stamp)
{
  unsigned int pathlen = str_len(path) ;
  unsigned int i ;
  if (!gensetdyn_new(&a->data, &i)) return 0 ;
  {
    char tmp[pathlen + 23] ;
    uint16_pack_big(tmp, (uint16)i) ;
    tmp[2] = '<' ;
    uint32_pack_big(tmp+3, options) ;
    tain_pack(tmp+7, limit) ;
    uint32_pack_big(tmp+19, (uint32)pathlen) ;
    byte_copy(tmp+23, pathlen, path) ;
    tmp[23+pathlen] = 0 ;
    if (!skaclient2_send(&a->connection, tmp, pathlen + 23, deadline, stamp)) goto fail ;
  }
  if (!skaclient2_getack(&a->connection, deadline, stamp)) goto fail ;
  *GENSETDYN_P(char, &a->data, i) = EAGAIN ;
  *u = i ;
  return 1 ;

 fail:
  gensetdyn_delete(&a->data, i) ;
  return 0 ;
}
